<?php

function getDigitalIn($ip, $port, $slot, $pass) {
	$value = getRawValue($ip, $port, 'GET /input' . $slot . '?PW=' . $pass . '&\n');
	return $value == 'OFF' ? 0 : 1;
}

function getDigitalOut($ip, $port, $slot, $pass) {
	$value = getRawValue($ip, $port, 'GET /output' . $slot . '?PW=' . $pass . '&\n');
	return $value == 'OFF' ? 0 : 1;
}

function getCounter($ip, $port, $slot, $pass) {
	return getRawValue($ip, $port, 'GET /counter' . $slot . '?PW=' . $pass . '&\n');
}

function setDigitalOut($ip, $port, $slot, $pass, $state) {
	$value = getRawValue($ip, $port, 'GET /outputaccess' . $slot . '?PW=' . $pass . '&State=' . ($state == 0 ? 'OFF' : 'ON') . '&\n');
	return (pow(2, $slot) & hexdec($value)) > 0 ? 1 : 0;
}

function getAnalogIO($ip, $port, $slot) {
	$value = getRawValue($ip, $port, 'GET /single' . $slot);
	return floatval(str_replace(',', '.', $value));
}

function setAnalogOut($ip, $port, $slot, $pass, $state) {
	$value = getRawValue($ip, $port, 'GET /outputaccess' . $slot . '?PW=' . $pass . '&State=' . $state . '&\n');
	return floatval(str_replace(',', '.', $value));
}

function getRawValue($ip, $port, $request) {
	$handle = @fsockopen($ip, $port, $errno, $errstr, 3);
	if($handle) {
		fwrite($handle, $request);
		$response = '';
		do {
			$data = fgets($handle, 2);
			if(ord($data) != 0)
				$response .= $data;
			else
				break;
		} while(true);
		fclose($handle);

		$parts = explode(";", utf8_encode($response));
		return $parts[count($parts) - 1];
	}
}

?>